# openforcefield.topology.TopologyVirtualSite

class `openforcefield.topology.``TopologyVirtualSite`(virtual_site, topology_molecule)

  A TopologyVirtualSite is a lightweight data structure that represents a single openforcefield.topology.molecule.VirtualSite in a Topology. A TopologyVirtualSite consists of two references – One to its fully detailed “VirtualSite”, an openforcefield.topology.molecule.VirtualSite, and another to its parent “topology_molecule”, which occupies a spot in the parent Topology’s TopologyMolecule list.

  As some systems can be very large, there is no always-existing representation of a TopologyVirtualSite. They are created on demand as the user requests them.

  Warning

  This API is experimental and subject to change.

  Attributes
    `atoms`

      Get the TopologyAtoms involved in this TopologyVirtualSite.

    `molecule`

      Get the reference Molecule that this TopologyVirtualSite belongs to.

    `topology_molecule`

      Get the TopologyMolecule that this TopologyVirtualSite belongs to.

    `topology_particle_index`

      Get the index of this particle in its parent Topology.

    `topology_virtual_site_index`

      Get the index of this virtual site in its parent Topology.

    `type`

      Get the type of this virtual site

    `virtual_site`

      Get the reference VirtualSite for this TopologyVirtualSite.

  Methods

  `atom`(self, index) | Get the atom at a specific index in this TopologyVirtualSite
  `from_bson`(serialized) | Instantiate an object from a BSON serialized representation.
  `from_dict`(d) | Static constructor from dictionary representation.
  `from_json`(serialized) | Instantiate an object from a JSON serialized representation.
  `from_messagepack`(serialized) | Instantiate an object from a MessagePack serialized representation.
  `from_pickle`(serialized) | Instantiate an object from a pickle serialized representation.
  `from_toml`(serialized) | Instantiate an object from a TOML serialized representation.
  `from_xml`(serialized) | Instantiate an object from an XML serialized representation.
  `from_yaml`(serialized) | Instantiate from a YAML serialized representation.
  `to_bson`(self) | Return a BSON serialized representation.
  `to_dict`(self) | Convert to dictionary representation.
  `to_json`(self[, indent]) | Return a JSON serialized representation.
  `to_messagepack`(self) | Return a MessagePack representation.
  `to_pickle`(self) | Return a pickle serialized representation.
  `to_toml`(self) | Return a TOML serialized representation.
  `to_xml`(self[, indent]) | Return an XML representation.
  `to_yaml`(self) | Return a YAML serialized representation.

  `__init__`(self, virtual_site, topology_molecule)
    Parameters
      virtual_site An openforcefield.topology.molecule.VirtualSite

        The reference virtual site

      topology_molecule An openforcefield.topology.TopologyMolecule

        The TopologyMolecule that this TopologyVirtualSite belongs to

  Methods

  `__init__`(self, virtual_site, topology_molecule) | Parameters
  `atom`(self, index) | Get the atom at a specific index in this TopologyVirtualSite
  `from_bson`(serialized) | Instantiate an object from a BSON serialized representation.
  `from_dict`(d) | Static constructor from dictionary representation.
  `from_json`(serialized) | Instantiate an object from a JSON serialized representation.
  `from_messagepack`(serialized) | Instantiate an object from a MessagePack serialized representation.
  `from_pickle`(serialized) | Instantiate an object from a pickle serialized representation.
  `from_toml`(serialized) | Instantiate an object from a TOML serialized representation.
  `from_xml`(serialized) | Instantiate an object from an XML serialized representation.
  `from_yaml`(serialized) | Instantiate from a YAML serialized representation.
  `to_bson`(self) | Return a BSON serialized representation.
  `to_dict`(self) | Convert to dictionary representation.
  `to_json`(self[, indent]) | Return a JSON serialized representation.
  `to_messagepack`(self) | Return a MessagePack representation.
  `to_pickle`(self) | Return a pickle serialized representation.
  `to_toml`(self) | Return a TOML serialized representation.
  `to_xml`(self[, indent]) | Return an XML representation.
  `to_yaml`(self) | Return a YAML serialized representation.

  Attributes

  `atoms` | Get the TopologyAtoms involved in this TopologyVirtualSite.
  `molecule` | Get the reference Molecule that this TopologyVirtualSite belongs to.
  `topology_molecule` | Get the TopologyMolecule that this TopologyVirtualSite belongs to.
  `topology_particle_index` | Get the index of this particle in its parent Topology.
  `topology_virtual_site_index` | Get the index of this virtual site in its parent Topology.
  `type` | Get the type of this virtual site
  `virtual_site` | Get the reference VirtualSite for this TopologyVirtualSite.